function get-filename($filter)
{
    Add-Type -AssemblyName system.Windows.Forms
	$InputFileLocation = New-Object System.Windows.Forms.OpenFileDialog

	$InputFileLocation.Filter = $filter
	$InputFileLocation.FilterIndex = 2
	$InputFileLocation.RestoreDirectory = $true

	$rc = $InputFileLocation.ShowDialog()
	if ($rc -eq [System.Windows.Forms.DialogResult]::OK)
	{
	$inputfile = $InputFileLocation.FileName
	}
	else
	{
	exit
	}
	$inputfile
}

$ErrorActionPreference = "Stop"

echo "   _                           ___ _                             _   _            __      _               "
echo "  /_\  _____   _ _ __ ___     /   (_) __ _  __ _ _ __   ___  ___| |_(_) ___ ___  / _\ ___| |_ _   _ _ __  "
echo " //_\\|_  / | | | '__/ _ \   / /\ / |/ _`` |/ _`` | '_ \ / _ \/ __| __| |/ __/ __| \ \ / _ \ __| | | | '_ \ "
echo "/  _  \/ /| |_| | | |  __/  / /_//| | (_| | (_| | | | | (_) \__ \ |_| | (__\__ \ _\ \  __/ |_| |_| | |_) |"
echo "\_/ \_/___|\__,_|_|  \___| /___,' |_|\__,_|\__, |_| |_|\___/|___/\__|_|\___|___/ \__/\___|\__|\__,_| .__/ "
echo "                                           |___/                                                   |_|    "
echo ""
echo "This wisard will help you through setting up diagnostics for your cloud service"

if((Get-ChildItem *.publishsettings).Count -ne 1)
{
echo "By prompting your default web browser should be opened and ask you to authorize and save your publish setting file"
$dummy = Read-Host -Prompt 'Press enter key when ready'
Get-AzurePublishSettingsFile
$dummy = Read-Host -Prompt 'Now browse to the downloaded file. Press enter key when ready'
$inputfile = Get-FileName "publishsettings (*.publishsettings)| *.publishsettings"
}
else
{
echo "Importing your publish setting"
$inputfile = (Get-ChildItem *.publishsettings).Name
}

Import-AzurePublishSettingsFile $inputfile

$subscriptions = Get-AzureSubscription
if(($subscriptions).count -ne 1)
{
$count=0
foreach ($sub in $subscriptions) {
Echo "[$count]: $($sub.subscriptionname)"
$count=$count+1
}
echo ""
$subscrNumber = Read-Host -Prompt 'Which one of these subscription should be used? (just write the index)'
$subscrName = ($subscriptions)[$subscrNumber].subscriptionname
}
else
{
$subscrName = ($subscriptions).subscriptionname
}

Select-Azuresubscription SubscriptionName $subscrName

$Accounts = Get-AzureStorageAccount
if($Accounts.count -ne 1)
{
$count=0

foreach ($sto in $Accounts.label) {
Echo "[$count]: $sto"
$count=$count+1
}
echo ""
$storageNumber = Read-Host -Prompt 'Which one of these storages should be used? (just write the index)'
$storageName = (($Accounts)[$storageNumber]).label
}
else
{
$storageName = $Accounts.label
}

$StorageAccount=$storageName.ToLower()

Set-AzureSubscription SubscriptionName $subscrName CurrentStorageAccountName $StorageAccount 

$services = Get-AzureService # | Group-Object -Property ServiceName

if($services.Count -eq 0)
{
$dummy = Read-Host -Prompt  'There is not any services yet. please create your service first (press enter key to exit)'
exit
}
if($srvices.Count -ne 2)
{
$count=0;
foreach ($service in $services) {
    "[$count] $($service.ServiceName) ($($service.Status))"
	$count=$count+1
    foreach ($ep in $service.ExtendedProperties.GetEnumerator()) {
        "	|_$($ep.Key): $($ep.Value)"
    }
}
$service_name_number = Read-Host -Prompt 'which one of these services you would like to add diagnostics to? (just write the index)'
}
else
{
$service_name_number = 0
}

$service_name = ($services[$service_name_number]).ServiceName

if((Get-ChildItem *.PubConfig.xml).Count -ne 1)
{
$webrole_diagconfigpath = Get-FileName "PubConfig.xml (*.PubConfig.xml)| *.PubConfig.xml"
}
else
{
$webrole_diagconfigpath = (Get-ChildItem *.PubConfig.xml).Name
}
$key = Read-Host -Prompt "please enter your account key for $StorageAccount"

$storageContext = New-AzureStorageContext -StorageAccountName $StorageAccount -StorageAccountKey $key

$pos1 = $webrole_diagconfigpath.IndexOf("PaaSDiagnostics.")
$pos2 = $webrole_diagconfigpath.IndexOf(".PubConfig.xml")
if(($pos1 -ne -1) -And ($pos2 -ne -1))
{
$roleName = $name.Substring($pos1+1, $pos2)
}
else
{
$roleName = Read-Host -Prompt 'please enter your role name'
}

Set-AzureServiceDiagnosticsExtension -StorageContext $storageContext -DiagnosticsConfigurationPath $webrole_diagconfigpath -ServiceName $service_name -Slot Production -Role $roleName



